Loading...
Searching...
No Matches
laex1: Updated eigensystem after rank-1 update.
Dense LA » Eigenvalues » Symmetric/Hermitian eigenvalues » Auxiliary routines

## Functions

magma_int_t | magma_dlaex1 (magma_int_t n, double *d, double *Q, magma_int_t ldq, magma_int_t *indxq, double rho, magma_int_t cutpnt, double *work, magma_int_t *iwork, magmaDouble_ptr dwork, magma_queue_t queue, magma_range_t range, double vl, double vu, magma_int_t il, magma_int_t iu, magma_int_t *info)
| DLAEX1 computes the updated eigensystem of a diagonal matrix after modification by a rank-one symmetric matrix.
magma_int_t | magma_dlaex1_m (magma_int_t ngpu, magma_int_t n, double *d, double *Q, magma_int_t ldq, magma_int_t *indxq, double rho, magma_int_t cutpnt, double *work, magma_int_t *iwork, magmaDouble_ptr dwork[], magma_queue_t queues[MagmaMaxGPUs][2], magma_range_t range, double vl, double vu, magma_int_t il, magma_int_t iu, magma_int_t *info)
| DLAEX1 computes the updated eigensystem of a diagonal matrix after modification by a rank-one symmetric matrix.
magma_int_t | magma_slaex1 (magma_int_t n, float *d, float *Q, magma_int_t ldq, magma_int_t *indxq, float rho, magma_int_t cutpnt, float *work, magma_int_t *iwork, magmaFloat_ptr dwork, magma_queue_t queue, magma_range_t range, float vl, float vu, magma_int_t il, magma_int_t iu, magma_int_t *info)
| SLAEX1 computes the updated eigensystem of a diagonal matrix after modification by a rank-one symmetric matrix.
magma_int_t | magma_slaex1_m (magma_int_t ngpu, magma_int_t n, float *d, float *Q, magma_int_t ldq, magma_int_t *indxq, float rho, magma_int_t cutpnt, float *work, magma_int_t *iwork, magmaFloat_ptr dwork[], magma_queue_t queues[MagmaMaxGPUs][2], magma_range_t range, float vl, float vu, magma_int_t il, magma_int_t iu, magma_int_t *info)
| SLAEX1 computes the updated eigensystem of a diagonal matrix after modification by a rank-one symmetric matrix.

## Detailed Description

## Function Documentation

## magma_dlaex1()

magma_int_t magma_dlaex1 | ( | magma_int_t | n,
|  | double * | d,
|  | double * | Q,
|  | magma_int_t | ldq,
|  | magma_int_t * | indxq,
|  | double | rho,
|  | magma_int_t | cutpnt,
|  | double * | work,
|  | magma_int_t * | iwork,
|  | magmaDouble_ptr | dwork,
|  | magma_queue_t | queue,
|  | magma_range_t | range,
|  | double | vl,
|  | double | vu,
|  | magma_int_t | il,
|  | magma_int_t | iu,
|  | magma_int_t * | info )

DLAEX1 computes the updated eigensystem of a diagonal matrix after modification by a rank-one symmetric matrix.

T = Q(in) ( D(in) + RHO * Z*Z' ) Q'(in) = Q(out) * D(out) * Q'(out)

where Z = Q'u, u is a vector of length N with ones in the CUTPNT and CUTPNT + 1 th elements and zeros elsewhere.

The eigenvectors of the original matrix are stored in Q, and the eigenvalues are in D. The algorithm consists of three stages:

The first stage consists of deflating the size of the problem when there are multiple eigenvalues or if there is a zero in the Z vector. For each such occurence the dimension of the secular equation problem is reduced by one. This stage is performed by the routine DLAED2.

The second stage consists of calculating the updated eigenvalues. This is done by finding the roots of the secular equation via the routine DLAED4 (as called by DLAED3). This routine also calculates the eigenvectors of the current problem.

The final stage consists of computing the updated eigenvectors directly using the updated eigenvalues. The eigenvectors for the current problem are multiplied with the eigenvectors from the overall problem.

Parameters

  [in] | n | INTEGER The dimension of the symmetric tridiagonal matrix. N >= 0.
  [in,out] | d | DOUBLE PRECISION array, dimension (N) On entry, the eigenvalues of the rank-1-perturbed matrix. On exit, the eigenvalues of the repaired matrix.
  [in,out] | Q | DOUBLE PRECISION array, dimension (LDQ,N) On entry, the eigenvectors of the rank-1-perturbed matrix. On exit, the eigenvectors of the repaired tridiagonal matrix.
  [in] | ldq | INTEGER The leading dimension of the array Q. LDQ >= max(1,N).
  [in,out] | indxq | INTEGER array, dimension (N) On entry, the permutation which separately sorts the two subproblems in D into ascending order. On exit, the permutation which will reintegrate the subproblems back into sorted order, i.e. D( INDXQ( I = 1, N ) ) will be in ascending order.
  [in] | rho | DOUBLE PRECISION The subdiagonal entry used to create the rank-1 modification.
  [in] | cutpnt | INTEGER The location of the last eigenvalue in the leading sub-matrix. min(1,N) <= CUTPNT <= N/2.
  | work | (workspace) DOUBLE PRECISION array, dimension (4*N + N**2)
  | iwork | (workspace) INTEGER array, dimension (4*N)
  | dwork | (workspace) DOUBLE PRECISION array, dimension (3*N*N/2+3*N)

  [in]

  range

  magma_range_t
  - = MagmaRangeAll: all eigenvalues will be found.
  - = MagmaRangeV: all eigenvalues in the half-open interval (VL,VU] will be found.
  - = MagmaRangeI: the IL-th through IU-th eigenvalues will be found.

  [in] | vl | DOUBLE PRECISION
  [in] | vu | DOUBLE PRECISION if RANGE=MagmaRangeV, the lower and upper bounds of the interval to be searched for eigenvalues. VL < VU. Not referenced if RANGE = MagmaRangeAll or MagmaRangeI.
  [in] | il | INTEGER
  [in] | iu | INTEGER if RANGE=MagmaRangeI, the indices (in ascending order) of the smallest and largest eigenvalues to be returned. 1 <= IL <= IU <= N, if N > 0; IL = 1 and IU = 0 if N = 0. Not referenced if RANGE = MagmaRangeAll or MagmaRangeV.

  [out]

  info

  INTEGER
  - = 0: successful exit.
  - < 0: if INFO = -i, the i-th argument had an illegal value.
  - > 0: if INFO = 1, an eigenvalue did not converge

## Further Details

Based on contributions by Jeff Rutter, Computer Science Division, University of California at Berkeley, USA Modified by Francoise Tisseur, University of Tennessee.

## magma_dlaex1_m()

magma_int_t magma_dlaex1_m | ( | magma_int_t | ngpu,
|  | magma_int_t | n,
|  | double * | d,
|  | double * | Q,
|  | magma_int_t | ldq,
|  | magma_int_t * | indxq,
|  | double | rho,
|  | magma_int_t | cutpnt,
|  | double * | work,
|  | magma_int_t * | iwork,
|  | magmaDouble_ptr | dwork[],
|  | magma_queue_t | queues[MagmaMaxGPUs][2],
|  | magma_range_t | range,
|  | double | vl,
|  | double | vu,
|  | magma_int_t | il,
|  | magma_int_t | iu,
|  | magma_int_t * | info )

DLAEX1 computes the updated eigensystem of a diagonal matrix after modification by a rank-one symmetric matrix.

    T = Q(in) ( D(in) + RHO * Z*Z' ) Q'(in) = Q(out) * D(out) * Q'(out)

where Z = Q'u, u is a vector of length N with ones in the CUTPNT and CUTPNT + 1 th elements and zeros elsewhere.

The eigenvectors of the original matrix are stored in Q, and the eigenvalues are in D. The algorithm consists of three stages:

The first stage consists of deflating the size of the problem when there are multiple eigenvalues or if there is a zero in the Z vector. For each such occurence the dimension of the secular equation problem is reduced by one. This stage is performed by the routine DLAED2.

The second stage consists of calculating the updated eigenvalues. This is done by finding the roots of the secular equation via the routine DLAED4 (as called by DLAED3). This routine also calculates the eigenvectors of the current problem.

The final stage consists of computing the updated eigenvectors directly using the updated eigenvalues. The eigenvectors for the current problem are multiplied with the eigenvectors from the overall problem.

Parameters

  [in] | ngpu | INTEGER Number of GPUs to use. ngpu > 0.
  [in] | n | INTEGER The dimension of the symmetric tridiagonal matrix. N >= 0.
  [in,out] | d | DOUBLE PRECISION array, dimension (N) On entry, the eigenvalues of the rank-1-perturbed matrix. On exit, the eigenvalues of the repaired matrix.
  [in,out] | Q | DOUBLE PRECISION array, dimension (LDQ,N) On entry, the eigenvectors of the rank-1-perturbed matrix. On exit, the eigenvectors of the repaired tridiagonal matrix.
  [in] | ldq | INTEGER The leading dimension of the array Q. LDQ >= max(1,N).
  [in,out] | indxq | INTEGER array, dimension (N) On entry, the permutation which separately sorts the two subproblems in D into ascending order. On exit, the permutation which will reintegrate the subproblems back into sorted order, i.e. D( INDXQ( I = 1, N ) ) will be in ascending order.
  [in] | rho | DOUBLE PRECISION The subdiagonal entry used to create the rank-1 modification.
  [in] | cutpnt | INTEGER The location of the last eigenvalue in the leading sub-matrix. min(1,N) <= CUTPNT <= N/2.
  | work | (workspace) DOUBLE PRECISION array, dimension (4*N + N**2)
  | iwork | (workspace) INTEGER array, dimension (4*N)
  | dwork | (devices workspaces) DOUBLE PRECISION array of arrays, dimension NRGPU. if NRGPU = 1 the dimension of the first workspace should be (3*N*N/2+3*N) otherwise the NRGPU workspaces should have the size ceil((N-N1) * (N-N1) / floor(ngpu/2)) + NB * ((N-N1) + (N-N1) / floor(ngpu/2))
  | queues | (device queues) magma_queue_t array, dimension (MagmaMaxGPUs,2)

  [in]

  range

  magma_range_t
  - = MagmaRangeAll: all eigenvalues will be found.
  - = MagmaRangeV: all eigenvalues in the half-open interval (VL,VU] will be found.
  - = MagmaRangeI: the IL-th through IU-th eigenvalues will be found.

  [in] | vl | DOUBLE PRECISION
  [in] | vu | DOUBLE PRECISION if RANGE=MagmaRangeV, the lower and upper bounds of the interval to be searched for eigenvalues. VL < VU. Not referenced if RANGE = MagmaRangeAll or MagmaRangeI.
  [in] | il | INTEGER
  [in] | iu | INTEGER if RANGE=MagmaRangeI, the indices (in ascending order) of the smallest and largest eigenvalues to be returned. 1 <= IL <= IU <= N, if N > 0; IL = 1 and IU = 0 if N = 0. Not referenced if RANGE = MagmaRangeAll or MagmaRangeV.

  [out]

  info

  INTEGER
  - = 0: successful exit.
  - < 0: if INFO = -i, the i-th argument had an illegal value.
  - > 0: if INFO = 1, an eigenvalue did not converge

## Further Details

Based on contributions by Jeff Rutter, Computer Science Division, University of California at Berkeley, USA Modified by Francoise Tisseur, University of Tennessee.

## magma_slaex1()

magma_int_t magma_slaex1 | ( | magma_int_t | n,
|  | float * | d,
|  | float * | Q,
|  | magma_int_t | ldq,
|  | magma_int_t * | indxq,
|  | float | rho,
|  | magma_int_t | cutpnt,
|  | float * | work,
|  | magma_int_t * | iwork,
|  | magmaFloat_ptr | dwork,
|  | magma_queue_t | queue,
|  | magma_range_t | range,
|  | float | vl,
|  | float | vu,
|  | magma_int_t | il,
|  | magma_int_t | iu,
|  | magma_int_t * | info )

SLAEX1 computes the updated eigensystem of a diagonal matrix after modification by a rank-one symmetric matrix.

T = Q(in) ( D(in) + RHO * Z*Z' ) Q'(in) = Q(out) * D(out) * Q'(out)

where Z = Q'u, u is a vector of length N with ones in the CUTPNT and CUTPNT + 1 th elements and zeros elsewhere.

The eigenvectors of the original matrix are stored in Q, and the eigenvalues are in D. The algorithm consists of three stages:

The first stage consists of deflating the size of the problem when there are multiple eigenvalues or if there is a zero in the Z vector. For each such occurence the dimension of the secular equation problem is reduced by one. This stage is performed by the routine SLAED2.

The second stage consists of calculating the updated eigenvalues. This is done by finding the roots of the secular equation via the routine SLAED4 (as called by SLAED3). This routine also calculates the eigenvectors of the current problem.

The final stage consists of computing the updated eigenvectors directly using the updated eigenvalues. The eigenvectors for the current problem are multiplied with the eigenvectors from the overall problem.

Parameters

  [in] | n | INTEGER The dimension of the symmetric tridiagonal matrix. N >= 0.
  [in,out] | d | REAL array, dimension (N) On entry, the eigenvalues of the rank-1-perturbed matrix. On exit, the eigenvalues of the repaired matrix.
  [in,out] | Q | REAL array, dimension (LDQ,N) On entry, the eigenvectors of the rank-1-perturbed matrix. On exit, the eigenvectors of the repaired tridiagonal matrix.
  [in] | ldq | INTEGER The leading dimension of the array Q. LDQ >= max(1,N).
  [in,out] | indxq | INTEGER array, dimension (N) On entry, the permutation which separately sorts the two subproblems in D into ascending order. On exit, the permutation which will reintegrate the subproblems back into sorted order, i.e. D( INDXQ( I = 1, N ) ) will be in ascending order.
  [in] | rho | REAL The subdiagonal entry used to create the rank-1 modification.
  [in] | cutpnt | INTEGER The location of the last eigenvalue in the leading sub-matrix. min(1,N) <= CUTPNT <= N/2.
  | work | (workspace) REAL array, dimension (4*N + N**2)
  | iwork | (workspace) INTEGER array, dimension (4*N)
  | dwork | (workspace) REAL array, dimension (3*N*N/2+3*N)

  [in]

  range

  magma_range_t
  - = MagmaRangeAll: all eigenvalues will be found.
  - = MagmaRangeV: all eigenvalues in the half-open interval (VL,VU] will be found.
  - = MagmaRangeI: the IL-th through IU-th eigenvalues will be found.

  [in] | vl | REAL
  [in] | vu | REAL if RANGE=MagmaRangeV, the lower and upper bounds of the interval to be searched for eigenvalues. VL < VU. Not referenced if RANGE = MagmaRangeAll or MagmaRangeI.
  [in] | il | INTEGER
  [in] | iu | INTEGER if RANGE=MagmaRangeI, the indices (in ascending order) of the smallest and largest eigenvalues to be returned. 1 <= IL <= IU <= N, if N > 0; IL = 1 and IU = 0 if N = 0. Not referenced if RANGE = MagmaRangeAll or MagmaRangeV.

  [out]

  info

  INTEGER
  - = 0: successful exit.
  - < 0: if INFO = -i, the i-th argument had an illegal value.
  - > 0: if INFO = 1, an eigenvalue did not converge

## Further Details

Based on contributions by Jeff Rutter, Computer Science Division, University of California at Berkeley, USA Modified by Francoise Tisseur, University of Tennessee.

## magma_slaex1_m()

magma_int_t magma_slaex1_m | ( | magma_int_t | ngpu,
|  | magma_int_t | n,
|  | float * | d,
|  | float * | Q,
|  | magma_int_t | ldq,
|  | magma_int_t * | indxq,
|  | float | rho,
|  | magma_int_t | cutpnt,
|  | float * | work,
|  | magma_int_t * | iwork,
|  | magmaFloat_ptr | dwork[],
|  | magma_queue_t | queues[MagmaMaxGPUs][2],
|  | magma_range_t | range,
|  | float | vl,
|  | float | vu,
|  | magma_int_t | il,
|  | magma_int_t | iu,
|  | magma_int_t * | info )

SLAEX1 computes the updated eigensystem of a diagonal matrix after modification by a rank-one symmetric matrix.

    T = Q(in) ( D(in) + RHO * Z*Z' ) Q'(in) = Q(out) * D(out) * Q'(out)

where Z = Q'u, u is a vector of length N with ones in the CUTPNT and CUTPNT + 1 th elements and zeros elsewhere.

The eigenvectors of the original matrix are stored in Q, and the eigenvalues are in D. The algorithm consists of three stages:

The first stage consists of deflating the size of the problem when there are multiple eigenvalues or if there is a zero in the Z vector. For each such occurence the dimension of the secular equation problem is reduced by one. This stage is performed by the routine SLAED2.

The second stage consists of calculating the updated eigenvalues. This is done by finding the roots of the secular equation via the routine SLAED4 (as called by SLAED3). This routine also calculates the eigenvectors of the current problem.

The final stage consists of computing the updated eigenvectors directly using the updated eigenvalues. The eigenvectors for the current problem are multiplied with the eigenvectors from the overall problem.

Parameters

  [in] | ngpu | INTEGER Number of GPUs to use. ngpu > 0.
  [in] | n | INTEGER The dimension of the symmetric tridiagonal matrix. N >= 0.
  [in,out] | d | REAL array, dimension (N) On entry, the eigenvalues of the rank-1-perturbed matrix. On exit, the eigenvalues of the repaired matrix.
  [in,out] | Q | REAL array, dimension (LDQ,N) On entry, the eigenvectors of the rank-1-perturbed matrix. On exit, the eigenvectors of the repaired tridiagonal matrix.
  [in] | ldq | INTEGER The leading dimension of the array Q. LDQ >= max(1,N).
  [in,out] | indxq | INTEGER array, dimension (N) On entry, the permutation which separately sorts the two subproblems in D into ascending order. On exit, the permutation which will reintegrate the subproblems back into sorted order, i.e. D( INDXQ( I = 1, N ) ) will be in ascending order.
  [in] | rho | REAL The subdiagonal entry used to create the rank-1 modification.
  [in] | cutpnt | INTEGER The location of the last eigenvalue in the leading sub-matrix. min(1,N) <= CUTPNT <= N/2.
  | work | (workspace) REAL array, dimension (4*N + N**2)
  | iwork | (workspace) INTEGER array, dimension (4*N)
  | dwork | (devices workspaces) REAL array of arrays, dimension NRGPU. if NRGPU = 1 the dimension of the first workspace should be (3*N*N/2+3*N) otherwise the NRGPU workspaces should have the size ceil((N-N1) * (N-N1) / floor(ngpu/2)) + NB * ((N-N1) + (N-N1) / floor(ngpu/2))
  | queues | (device queues) magma_queue_t array, dimension (MagmaMaxGPUs,2)

  [in]

  range

  magma_range_t
  - = MagmaRangeAll: all eigenvalues will be found.
  - = MagmaRangeV: all eigenvalues in the half-open interval (VL,VU] will be found.
  - = MagmaRangeI: the IL-th through IU-th eigenvalues will be found.

  [in] | vl | REAL
  [in] | vu | REAL if RANGE=MagmaRangeV, the lower and upper bounds of the interval to be searched for eigenvalues. VL < VU. Not referenced if RANGE = MagmaRangeAll or MagmaRangeI.
  [in] | il | INTEGER
  [in] | iu | INTEGER if RANGE=MagmaRangeI, the indices (in ascending order) of the smallest and largest eigenvalues to be returned. 1 <= IL <= IU <= N, if N > 0; IL = 1 and IU = 0 if N = 0. Not referenced if RANGE = MagmaRangeAll or MagmaRangeV.

  [out]

  info

  INTEGER
  - = 0: successful exit.
  - < 0: if INFO = -i, the i-th argument had an illegal value.
  - > 0: if INFO = 1, an eigenvalue did not converge

## Further Details

Based on contributions by Jeff Rutter, Computer Science Division, University of California at Berkeley, USA Modified by Francoise Tisseur, University of Tennessee.